%--------------------------------------------
%   Generalized Hebbian Algorithm
%   (section 8.6)
%--------------------------------------------

% 1. load the image data
   load gha_data

% 2. set the colormap
   colormap(gray(256))

% 3. run the algorithm
   W=gha_getweights(parn,1,8,.0001);

% 4. determine mask coefficients
%    display masks and reconstructed image with unquantized coeffs
   c=gha_getcoeffs(parn,W,1);

% 5. quantize the coeffecients according user specified bit rate
%    and recompose the image
   [I, st, xla] = gha_quantcoeffs(c,W,parn,[7 7 6 4 3 3 2 2]);

% 6. display the reconstructed image
   subplot(2,2,4) 
   pim(I)
